<?php
//  ------------------------------------------------------------------------ //
//                           PHP-ServerError                                 //
//                     Copyright (c) 2003,2004 indyone                            //
//                                   2004 edgar soldin                       //
//                  <http://www.servererror.net/info/>                       //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

define("PROGRAM","Servererror-PHP");
define("VERSION","0.3");
define("LASTMODDATE","28.03.2004");
define("AUTHORS","Ioannis Stavrinos,". 
	 							 "indyone at ee dot teiath dot gr,".
	 							 "http://nemesis.ee.teiath.gr/~indyone; ".
	 							 "Edgar Soldin,".
	 							 "edgar at servererror dot net,".
	               "http://www.soldin.de");
define("COPYRIGHT","2004 Ioannis Stavrinos, Edgar Soldin");
define("LICENSE","GNU General Public License, http://www.gnu.org");


/*
	PHP-ServerError version 0.3
	
	PHP-Coded by 
	 Ioannis Stavrinos, 
	 indyone at ee dot teiath dot gr, 
	 http://nemesis.ee.teiath.gr/~indyone
	
	Original script, idea and some more PHP 
	 by Edgar Soldin, 
	 edgar at servererror dot net, 
	 http://www.soldin.de
	 
	More information about this script go to http://www.servererror.net/info
		
	Description: 
	 This is the PHP version of the original script of www.servererror.net 
	 which shows a fake (funny) server error message each time it is requested.
		
	Tip: 
	 Force to show an error message by entering the line number in the query 
	 string of the url	eg. http://www.myserver.org/notexists.html?24 
	 This will show the	error message in the 24th line. Note that the displayed
	 error code will have the given number plus 600 as the fake errors start at
	 this value. 
*/
/*
	Options:
	 The relative or absolute path to the file with the error codes.
	 This file must have in each line, one error message.
	 The lines that are empty or start with // are ignored.
*/	
$error_filename = 'info/FakeErrorcodes.txt';
/*
	 The relative or absolute path to the template file, which will be used to create
	 the look & feel of the error page.
	 
	 You can use one of the following options:
    'apache'            - an original Apache error page design
	  'iis'               - an Microsoft IIS error page design
	  'servererror_new'		- a new redesign of the original design
	 	'servererror_old' 	- the traditional servererror.net page look (was a modified 
	 	                      Netscape webserver error design)
*/
$error_template = 'servererror_new';
/*
	The error codes starts from the following number.
	eg. if $start_number = 600, the line #10 has the error code 610
*/
$start_number = 600;

/*
	Don't edit the following unless you know what you are doing ;-)
*/
if (!file_exists($error_filename)) {
	$error_code = 0;
	$error_message = 'The server has failed to analyse the request error because the file that has the error codes is not readable.';
} else {
	$contents = file($error_filename);
	//ereg('[0-9]*', substr(strrchr($_SERVER['REQUEST_URI'], '?'), 1), $force_code);
	preg_match("/^(.*)\?([0-9]*)$/",$_SERVER['REQUEST_URI'],$force_code);
	$force_code = $force_code[2];
	
	$errors = array();
	foreach ($contents as $line) {		
		// decide whether it's a hint or a message or a title
		if ( preg_match('/^[\s\/]/', $line) ){
			continue;
		}elseif ( preg_match("/^\+(.*)/", $line, $match) ){
			$errors[count($errors)-1]->title = $match[1];
		}elseif ( preg_match("/^-(.*)/", $line, $match) ){
			$errors[count($errors)-1]->tips[] = $match[1];
			//print_r($errors[count($errors)-1]->tips); echo "H<br>";
		}else { 
			$errors[] = new Error($line);
			//echo $error->msg."<br>";  
		}
		//$error_message = trim($contents[$error_code]);
	}
	
	
	// create a random number OR take the one given in URL
	$error_code = !is_null($force_code) ? (int)$force_code : rand(0, sizeof($errors)-1);
	
	if($error_code>(count($errors)-1) || $error_code<0){
		$error_message = "The error code $error_code is currently unknown. Use a code between 0 and ".count($errors)." for a proper error.";			
	}else {
		$error_message = $errors[$error_code]->msg;
		$error_tips = $errors[$error_code]->tips;
		$error_title = $errors[$error_code]->title;
	}

}

$error_code += $start_number;
$error_url = substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/'));
$error_protocol = strtoupper($_SERVER['SERVER_PROTOCOL']);
$error_host = $_SERVER['SERVER_NAME'];
$error_port = $_SERVER['SERVER_PORT'];
include('templates/'.$error_template.'.php');

class Error{
	var $msg = "";
	var $title = "";
	var $tips = array();
	
	function Error($msg){ if(!empty($msg)) $this->msg = $msg; }
}
?>